
BFC_Silithus = {}; -- Initialize the BFC_Silithus namespace

function BFC_Silithus.OnLoad()
	-- Create the helper module and register it with the BFC system.
	local modobj = {
		Name = "Silithus Helper", -- A unique name, doesn't need to be the zone name
		Author = "Vallerius", -- Give yourself credit. Not used yet, might appear later in a management screen
		Version = "1.0", -- Also unused for now
		Type = "ZONE_HELPER", -- Must be ZONE_HELPER for per-zone helper objects
		SetActive = BFC_Silithus.SetActive, -- Function to enable/disable the zone
		IsActiveZone = BFC_Silithus.IsActiveZone, -- Function to determine if we're in a target zone
	};
	BFC_Common.RegisterHelperModule(modobj);
end

-- Called by the module dispatcher whenever we enter/leave an active zone
function BFC_Silithus.SetActive(state)
	if(state == true) then
		BFC_Silithus_Frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE"); 
		BFC_Silithus_Frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE"); 
		BFC_Silithus_Frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
		
		BFC_Radio.SetLocalMenuItems(BFC_Strings.CommsMenu_Silithus);
	else
		BFC_Silithus_Frame:UnregisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE"); 
		BFC_Silithus_Frame:UnregisterEvent("CHAT_MSG_BG_SYSTEM_HORDE"); 
		BFC_Silithus_Frame:UnregisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
		
		BFC_Radio.SetLocalMenuItems(nil);
	end
end

-- Called by the module dispatcher to determine if we're in an active zone
function BFC_Silithus.IsActiveZone(zone)
	if(zone == "Silithus") then -- FIXME: add to strings
		return true;
	else
		return false;
	end
end

-- Your standard event handler
function BFC_Silithus.OnEvent()
	if(event == "CHAT_MSG_BG_SYSTEM_ALLIANCE" or event == "CHAT_MSG_BG_SYSTEM_HORDE" or event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
		BFC.Log(BFC.LOG_DEBUG, "Got " .. event);
	end
end