-------------------------------------------------------------------------------
-- English/Default
-------------------------------------------------------------------------------

-- Bindings
BINDING_HEADER_BFC_HEADER = "Battlefield Commander";
BINDING_NAME_BFC_GLOBALCOMMSMENU = "Global Comms Menu";
BINDING_NAME_BFC_LOCALCOMMSMENU = "Local Comms Menu";

BFC_Strings = {
	bfcommander = "Battlefield Commander",
	options = "BFC Options",
	
	-- setchannel might be unused
	scale = "Scale",
	objectives = "Objectives",
	menu_narrowmode = "Narrow Mode",
	menu_autoshowbg = "BG Auto Show",
	groupobjective = "Group %s objective",
	yourobjective = "Your objective",
	
	
};


-- Log message prefixes
BFC_Strings.LogPrefix = {
	"<BFC>Debug: ",
	"<BFC>Warning: ",
	"<BFC>Error: ",
	"<BFC> ",
};


-- Error messages
BFC_Strings.Errors = {
	cannotshow = "BFC cannot be displayed when in an instance.",
	notingroup = "You must be in a party or raid to use that function.",
	-- common
	modinuse = "Cannot register module %q, name already in use.",
	unknownmodtype = "Cannot register module %q, unknown type %q.",
	nomodname = "Cannot register module - no name and/or type found.",
	noupdatefunc = "No update function named %q is registered.",
	updatefuncregistered = "An update function named %q is already registered.",
	
	-- comms
	ccpairregistered = "The component-command pair %q is already registered.",
	noccpairregistered = "No component-command pair %q is registered.",
	
	-- radio
	msgnotfound = "Message not found.",
}


-- Things that the WSG herald yells
BFC_Strings.WSG = {
	zone = "Warsong Gulch",
	herald = "Warsong Gulch Herald",
	alliance = "Alliance",
	horde = "Horde",
	atbase = "At base",
	picked = "picked",
	captured = "captured",
	wins = "wins",
	returned = "returned",
	dropped = "dropped",
	unknown = "Unknown",
	
	-- WSG
	rezwavedefault = "Rez wave in: unknown",
	rezwave = "Rez wave in: %ss",
};


-- The names of the classes
BFC_Strings.Classes = {
	WARLOCK = "Warlock",
	WARRIOR = "Warrior",
	HUNTER = "Hunter",
	MAGE = "Mage",
	PRIEST = "Priest",
	DRUID = "Druid",
	PALADIN = "Paladin",
	SHAMAN = "Shaman",
	ROGUE = "Rogue",
}


-- Just a plain old array with up to 5 entries, same for the zone-specific ones
BFC_Strings.CommsMenu = {
	"Enemy spotted!",
	"Situation under control.",
	"Need reinforcements!",
	"Roger that!",
	"Negative.",
}


-- gulch-specific comms menu
BFC_Strings.CommsMenu_WSG = {
	"Ramp",
	"Tunnel",
	"Graveyard",
	"Flag Room",
	"Balcony",
	"Roof",
	"Midfield",
}