
BFC_Options = {};

local DefaultOptions = {
	opacity = 0.7,
	locked = false,
	showPlayers = true,
	size = {
	w = 175,
	h = 131},
	settingsversion = 1,
	channel = "",
	narrow = false,
	enableRadio = true,
	autoShowBg = false,
};

-- Initialize the options from SavedVariablesByCharacter, handle any version
-- mismatches if they appear
function BFC_Options.Init()
	if(not BattlefieldCommanderOptions) then
		-- could not load options, use defaults
		BattlefieldCommanderOptions = DefaultOptions;
	end
end

-- Use this to handle version conflicts
function BFC_Options.CheckNewOption(name)
	if(not BattlefieldCommanderOptions[name]) then
		BattlefieldCommanderOptions[name] = DefaultOptions[name];
	end
end

-- Retrieve a setting
function BFC_Options.get(name)
	return BattlefieldCommanderOptions[name];
end

-- Store a setting
function BFC_Options.set(name, value)
	BattlefieldCommanderOptions[name] = value;
end

-- Toggle a true/false setting
function BFC_Options.toggle(name)
	BattlefieldCommanderOptions[name] = not BattlefieldCommanderOptions[name];
	return BattlefieldCommanderOptions[name];
end